% Num. Math. - FS 2014 - Serie 13 Aufgabe 1 - EW bestimmen mit
% Rückwaerts/Vorwaertsiteration

A=[11 -11 10 5; -11 25 -4 -12; 10 -4 21 3; 5 -12 3 6];
TOL=1e-4;
maxit=50;
% a) Rueckwaerts-Iteration
y0=[1 2 -1 5];
N=norm(y0);
x_rw(:,1)=sign(y0(1))/N*y0;
[L,R,P]=lu(A);
for k=1:maxit
    c=L\(P*x_rw(:,k));
    yk=R\c;
    N=norm(yk);
    x_rw(:,k+1)=sign(yk(1))/N*yk;
    Delta=norm(x_rw(:,k+1)-x_rw(:,k));
    if Delta<=TOL
        break
    end
end
ev_min=x_rw(:,end)
lambda_min=sign(yk(1))/N

% b) Vorwaerts-Iteration
y0=[-1 2 -1 -1];
N=norm(y0);
x_vw(:,1)=sign(y0(1))/N*y0;
for k=1:maxit
    yk=A*x_vw(:,k);
    N=norm(yk);
    x_vw(:,k+1)=sign(yk(1))/N*yk;
    Delta=norm(x_vw(:,k+1)-x_vw(:,k));
    if Delta<=TOL
        break
    end
end
ev_max=x_vw(:,end)
lambda_max=sign(yk(1))*N

% c) Vergleichen mit eig
[v,d]=eig(A);
rel_err_lambda_min=abs(lambda_min-d(1,1))/abs(d(1,1))
rel_err_lambda_max=abs(lambda_max-d(end,end))/abs(d(end,end))
rel_err_ev_min=norm(ev_min-v(:,1))
rel_err_ev_max=norm(ev_max-v(:,end))
